=== debian/changelog ===
passt (0.0~git20230216.4663ccc-1) unstable; urgency=medium

  * New upstream version 0.0~git20230216.4663ccc

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 17 Feb 2023 12:48:47 +0100

passt (0.0~git20221116.ace074c-1) unstable; urgency=medium

  * New upstream version 0.0~git20221116.ace074c. Most relevant
    change: AppArmor profile actually covers both pasta(1) and
    passt(1)
  * Fix Vcs-Browser and Vcs-Git links in debian/control
  * Build with -DVERSION corresponding to current package version
  * Move copy of AppArmor profile to debian/passt.install

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 16 Nov 2022 22:42:50 +0100

passt (0.0~git20221104.e308018-1) unstable; urgency=medium

  * Initial release. Closes: #1010498

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 04 Nov 2022 18:26:31 +0100
