=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Stefano Brivio <sbrivio@redhat.com>
 Build-Depends: debhelper-compat (= 13), dh-apparmor
 Rules-Requires-Root: no
-Standards-Version: 4.6.1.0
+Standards-Version: 4.6.2
 Homepage: https://passt.top/
 Vcs-Browser: https://salsa.debian.org/sbrivio/passt
 Vcs-Git: https://salsa.debian.org/sbrivio/passt.git
