=== debian/changelog ===
passt (0.0~git20230627.289301b-1) unstable; urgency=medium

  * New upstream version 0.0~git20230627.289301b
  * Update licensing information to new licensing terms from upstream
    (GPLv2+ instead of AGPLv3+)
  * Fix cross-build in Debian package itself by overriding TARGET via
    dh_auto_install with target architecture

 -- Stefano Brivio <sbrivio@redhat.com>  Thu, 27 Mar 2023 19:31:18 +0200
