=== debian/changelog ===
passt (0.0~git20240220.1e6f92b-1) unstable; urgency=medium

  * New upstream version 0.0~git20240220.1e6f92b:
    - pasta(1) now quits as expected once the container goes away when
      used as network back-end for buildah(1)
    - fix possible mix-up of ports for UDP outbound flows originating
      from -U outbound forwarding option

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 20 Feb 2024 11:05:49 +0100

passt (0.0~git20240216.08344da-1) unstable; urgency=medium

  * New upstream version 0.0~git20240216.08344da:
    - default gateway can now be sourced from host multipath routes as
      well
    - on failure of the inotify watch used by pasta to exit when a
      nsfs-bound namespace, fall back to a simple timed check

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 16 Feb 2024 11:02:16 +0100

passt (0.0~git20231230.f091893-1) unstable; urgency=medium

  * New upstream version 0.0~git20231230.f091893:
    - increase lifetime for router and prefix validity in router
      advertisements to maximum allowed values
    - pick most specific IPv6 global unicast address (via netlink) for
      guest configuration, if multiple addresses are available

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 02 Jan 2024 17:07:41 +0100

passt (0.0~git20231204.b86afe3-1) unstable; urgency=medium

  * New upstream version 0.0~git20231204.b86afe3
  * Fixes build warnings on 32-bit architectures due to mismatching
    format specifiers

 -- Stefano Brivio <sbrivio@redhat.com>  Mon, 04 Dec 2023 11:14:52 +0100

passt (0.0~git20231107.74e6f48-1) unstable; urgency=medium

  * New upstream version 0.0~git20231107.74e6f48
  * Most notable fixed issue: DNS resolution stopped working after a
    relatively long time, https://bugs.passt.top/show_bug.cgi?id=57
  * debian/rules: 'host' is the machine we're building for, not 'build'

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 07 Nov 2023 14:10:52 +0100

passt (0.0~git20231004.f851084-1) unstable; urgency=medium

  * New upstream version 0.0~git20231004.f851084
  * Most notable fix: workaround to trigger TCP window update in kernel
    after it was reported empty, on socket side, very visible with
    default values for rmem_max and wmem_max
    (https://bugs.passt.top/show_bug.cgi?id=74)

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 10 Oct 2023 00:13:04 +0200

passt (0.0~git20230908.05627dc-1) unstable; urgency=medium

  * debian/rules: Pass DEB_BUILD_GNU_CPU to Makefile, not DEB_BUILD_ARCH
  * debian/rules: Override pasta symbolic links with hard links
  * debian/rules: Install new pasta profile using dh_apparmor
  * New upstream version 0.0~git20230908.05627dc

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 08 Sep 2023 17:39:07 +0200

passt (0.0~git20230823.a7e4bfb-1) unstable; urgency=medium

  * New upstream version 0.0~git20230823.a7e4bfb
  * Several fixes for pasta --config-net operation, most importantly:
    don't copy lifetime information of addresses from host, avoid
    unexpected expiration of IPv4 addresses

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 23 Aug 2023 23:10:18 +0200
