=== debian/changelog ===
passt (0.0~git20240624.1ee2eca-1) unstable; urgency=medium

  * New upstream version 0.0~git20240624.1ee2eca:
    - Outbound connections now work when ip_non_local_bind sysctls are set:
      https://github.com/containers/podman/issues/23003
    - Start even if we have multiple interfaces but no default routes:
      https://bugzilla.redhat.com/show_bug.cgi?id=2277954
    - Fix duplicating routes to containers with 'noprefixroute' addresses:
      https://github.com/containers/podman/issues/22824
    - Don't fail to duplicate routes originated from OSPF daemons:
      https://github.com/containers/podman/issues/22960
    - Always log to standard error during initialisation, and if in foreground
    - Fix UDP port forwarding with different original and target ports:
      https://bugs.passt.top/show_bug.cgi?id=80 was reintroduced and has been
      fixed again

 -- Stefano Brivio <sbrivio@redhat.com>  Mon, 24 Jun 2024 18:03:28 +0200

passt (0.0~git20240607.8a83b53-1) unstable; urgency=medium

  * New upstream version 0.0~git20240607.8a83b53, most notable fix:
    avoid triggering an assertion if container or guest try to access
    an unreachable port using the address of the default gateway
    (https://github.com/containers/podman/issues/22925)

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 07 Jun 2024 20:52:50 +0200

passt (0.0~git20240523.765eb0b-1) unstable; urgency=medium

  * New upstream version 0.0~git20240523.765eb0b

 -- Stefano Brivio <sbrivio@redhat.com>  Thu, 23 May 2024 19:48:09 +0200

passt (0.0~git20240426.d03c4e2-1) unstable; urgency=medium

  * Actually install pasta's AppArmor profile from passt.install
  * debian/control: Bump standards version from 4.6.2 to 4.7.0
  * New upstream version 0.0~git20240426.d03c4e2

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 26 Apr 2024 08:39:30 +0200

passt (0.0~git20240326.4988e2b-1) unstable; urgency=medium

  * debian/rules: Include pkg-info.mk
  * New upstream version 0.0~git20240326.4988e2b: never send TCP
    segments with none of ACK, SYN or RST flags to avoid unexpected
    connection resets (https://github.com/containers/podman/issues/22146)

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 26 Mar 2024 10:28:50 +0100

passt (0.0~git20240320.71dd405-1) unstable; urgency=medium

  * New upstream version 0.0~git20240320.71dd405, most notable fix:
    pasta(1) hang on start-up with Linux kernel versions 6.9 and later
  * debian/rules: It's DEB_VERSION_UPSTREAM, not DEB_UPSTREAM_VERSION

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 20 Mar 2024 12:14:37 +0100
