=== debian/changelog ===
passt (0.0~git20240814.61c0b0d-1) unstable; urgency=medium

  * New upstream version 0.0~git20240814.61c0b0d:
    - Avoid triggering an ASSERT() checking that the port isn't zero
      when the container sends a TCP packet to port zero

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 14 Aug 2024 13:54:49 +0200

passt (0.0~git20240806.ee36266-1) unstable; urgency=medium

  * New upstream version 0.0~git20240806.ee36266:
    - Fix possible TCP transfer hang on local pasta(1) connections:
      https://github.com/containers/podman/issues/23517

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 06 Aug 2024 15:46:13 +0200

passt (0.0~git20240726.57a21d2-1) unstable; urgency=medium

  * New upstream version 0.0~git20240726.57a21d2:
    - Unified flow table for all flow types (TCP, UDP, ICMP), with the side
      effect of fixing possible inconsistencies in UDP source port tracking
    - Forwarding for DNS queries over TCP and DNS over TLS (dot) now supported

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 26 Jul 2024 15:54:22 +0200
